/*
 * Intel ACPI Component Architecture
 * AML/ASL+ Disassembler version 20180427 (64-bit version)(RM)
 * Copyright (c) 2000 - 2018 Intel Corporation
 * 
 * Disassembling to non-symbolic legacy ASL operators
 *
 * Disassembly of SSDT-2-SataAhci.aml, Tue Nov 26 00:12:10 2019
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x000018D2 (6354)
 *     Revision         0x01
 *     Checksum         0x15
 *     OEM ID           "LENOVO"
 *     OEM Table ID     "SataAhci"
 *     OEM Revision     0x00001000 (4096)
 *     Compiler ID      "INTL"
 *     Compiler Version 0x20141107 (538185991)
 */
DefinitionBlock ("", "SSDT", 1, "LENOVO", "SataAhci", 0x00001000)
{
    /*
     * iASL Warning: There was 1 external control method found during
     * disassembly, but only 0 were resolved (1 unresolved). Additional
     * ACPI tables may be required to properly disassemble the code. This
     * resulting disassembler output file may not compile because the
     * disassembler did not know how many arguments to assign to the
     * unresolved methods. Note: SSDTs can be dynamically loaded at
     * runtime and may or may not be available via the host OS.
     *
     * To specify the tables needed to resolve external control method
     * references, the -e option can be used to specify the filenames.
     * Example iASL invocations:
     *     iasl -e ssdt1.aml ssdt2.aml ssdt3.aml -d dsdt.aml
     *     iasl -e dsdt.aml ssdt2.aml -d ssdt1.aml
     *     iasl -e ssdt*.aml -d dsdt.aml
     *
     * In addition, the -fe option can be used to specify a file containing
     * control method external declarations with the associated method
     * argument counts. Each line of the file must be of the form:
     *     External (<method pathname>, MethodObj, <argument count>)
     * Invocation:
     *     iasl -fe refs.txt -d dsdt.aml
     *
     * The following methods were unresolved and many not compile properly
     * because the disassembler had to guess at the number of arguments
     * required for each:
     */
    External (_SB_.PCI0.GPCB, UnknownObj)    // Warning: Unknown object
    External (_SB_.PCI0.SAT1, DeviceObj)    // Warning: Unknown object
    External (_SB_.PCI0.SAT1.SDSM, IntObj)    // Warning: Unknown object
    External (DPP0, UnknownObj)    // Warning: Unknown object
    External (DPP1, UnknownObj)    // Warning: Unknown object
    External (DPP2, UnknownObj)    // Warning: Unknown object
    External (DPP3, UnknownObj)    // Warning: Unknown object
    External (DPP4, UnknownObj)    // Warning: Unknown object
    External (DVS0, UnknownObj)    // Warning: Unknown object
    External (DVS1, UnknownObj)    // Warning: Unknown object
    External (DVS2, UnknownObj)    // Warning: Unknown object
    External (DVS3, UnknownObj)    // Warning: Unknown object
    External (ND11, IntObj)    // Warning: Unknown object
    External (ND12, IntObj)    // Warning: Unknown object
    External (ND13, IntObj)    // Warning: Unknown object
    External (ND21, IntObj)    // Warning: Unknown object
    External (ND22, IntObj)    // Warning: Unknown object
    External (ND23, IntObj)    // Warning: Unknown object
    External (NEA1, IntObj)    // Warning: Unknown object
    External (NEA2, IntObj)    // Warning: Unknown object
    External (NEA3, IntObj)    // Warning: Unknown object
    External (NEB1, IntObj)    // Warning: Unknown object
    External (NEB2, IntObj)    // Warning: Unknown object
    External (NEB3, IntObj)    // Warning: Unknown object
    External (NEC1, IntObj)    // Warning: Unknown object
    External (NEC2, IntObj)    // Warning: Unknown object
    External (NEC3, IntObj)    // Warning: Unknown object
    External (NIT1, IntObj)    // Warning: Unknown object
    External (NIT2, IntObj)    // Warning: Unknown object
    External (NIT3, IntObj)    // Warning: Unknown object
    External (NL11, IntObj)    // Warning: Unknown object
    External (NL12, IntObj)    // Warning: Unknown object
    External (NL13, IntObj)    // Warning: Unknown object
    External (NLD1, IntObj)    // Warning: Unknown object
    External (NLD2, IntObj)    // Warning: Unknown object
    External (NLD3, IntObj)    // Warning: Unknown object
    External (NLR1, IntObj)    // Warning: Unknown object
    External (NLR2, IntObj)    // Warning: Unknown object
    External (NLR3, IntObj)    // Warning: Unknown object
    External (NMB1, IntObj)    // Warning: Unknown object
    External (NMB2, IntObj)    // Warning: Unknown object
    External (NMB3, IntObj)    // Warning: Unknown object
    External (NMV1, IntObj)    // Warning: Unknown object
    External (NMV2, IntObj)    // Warning: Unknown object
    External (NMV3, IntObj)    // Warning: Unknown object
    External (NPB1, IntObj)    // Warning: Unknown object
    External (NPB2, IntObj)    // Warning: Unknown object
    External (NPB3, IntObj)    // Warning: Unknown object
    External (NPC1, IntObj)    // Warning: Unknown object
    External (NPC2, IntObj)    // Warning: Unknown object
    External (NPC3, IntObj)    // Warning: Unknown object
    External (NPM1, IntObj)    // Warning: Unknown object
    External (NPM2, IntObj)    // Warning: Unknown object
    External (NPM3, IntObj)    // Warning: Unknown object
    External (NPV1, IntObj)    // Warning: Unknown object
    External (NPV2, IntObj)    // Warning: Unknown object
    External (NPV3, IntObj)    // Warning: Unknown object
    External (NRA1, IntObj)    // Warning: Unknown object
    External (NRA2, IntObj)    // Warning: Unknown object
    External (NRA3, IntObj)    // Warning: Unknown object
    External (PCIC, MethodObj)    // Warning: Unknown method, guessing 1 arguments
    External (PCID, IntObj)    // Warning: Unknown object

    Scope (\_SB.PCI0.SAT1)
    {
        Device (PRT0)
        {
            Name (DIP0, 0x00)
            Name (FDEV, Zero)
            Name (FDRP, Zero)
            Name (HDTF, Buffer (0x0E)
            {
                /* 0000 */  0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00,
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5             
            })
            Name (HETF, Buffer (0x15)
            {
                /* 0000 */  0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00,
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5, 0x10, 0x09,
                /* 0010 */  0x00, 0x00, 0x00, 0xA0, 0xEF                   
            })
            Name (ERTF, Buffer (0x15)
            {
                /* 0000 */  0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00,
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5, 0x5F, 0x00,
                /* 0010 */  0x00, 0x00, 0x00, 0xA0, 0xEF                   
            })
            Name (HPTF, Buffer (0x15)
            {
                /* 0000 */  0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00,
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5, 0x10, 0x03,
                /* 0010 */  0x00, 0x00, 0x00, 0xA0, 0xEF                   
            })
            Name (HQTF, Buffer (0x1C)
            {
                /* 0000 */  0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00,
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5, 0x10, 0x03,
                /* 0010 */  0x00, 0x00, 0x00, 0xA0, 0xEF, 0x10, 0x09, 0x00,
                /* 0018 */  0x00, 0x00, 0xA0, 0xEF                         
            })
            Name (HXTF, Buffer (0x1C)
            {
                /* 0000 */  0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00,
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5, 0x5F, 0x00,
                /* 0010 */  0x00, 0x00, 0x00, 0xA0, 0xEF, 0x10, 0x03, 0x00,
                /* 0018 */  0x00, 0x00, 0xA0, 0xEF                         
            })
            Name (DDTF, Buffer (0x0E)
            {
                /* 0000 */  0x00, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xE3, 0x00,
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xE3             
            })
            CreateByteField (DDTF, 0x01, DTAT)
            CreateByteField (DDTF, 0x08, DTFT)
            Name (DGTF, Buffer (0x15)
            {
                /* 0000 */  0x00, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xE3, 0x00,
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xE3, 0x10, 0x03,
                /* 0010 */  0x00, 0x00, 0x00, 0xA0, 0xEF                   
            })
            CreateByteField (DGTF, 0x01, GTAT)
            CreateByteField (DGTF, 0x08, GTFT)
            Name (_ADR, 0xFFFF)  // _ADR: Address
            Scope (\_SB.PCI0.SAT1)
            {
                Method (_DSM, 4, Serialized)  // _DSM: Device-Specific Method
                {
                    If (PCIC (Arg0))
                    {
                        Return (PCID)
                        Arg0
                        Arg1
                        Arg2
                        Arg3
                    }

                    If (CondRefOf (\_SB.PCI0.SAT1.SDSM))
                    {
                        Return (\_SB.PCI0.SAT1.SDSM)
                        Arg0
                        Arg1
                        Arg2
                        Arg3
                    }

                    Return (0x00)
                }

                Method (RDCA, 5, Serialized)
                {
                    OperationRegion (RPAL, SystemMemory, Add (\_SB.PCI0.GPCB, Add (0x000B8100, Arg1)), 0x04)
                    Field (RPAL, DWordAcc, Lock, Preserve)
                    {
                        RPCD,   32
                    }

                    OperationRegion (EPAC, SystemMemory, Add (\_SB.PCI0.GPCB, 0x000B8308), 0x08)
                    Field (EPAC, DWordAcc, Lock, Preserve)
                    {
                        CAIR,   32, 
                        CADR,   32
                    }

                    OperationRegion (NCRG, SystemMemory, Add (\_SB.PCI0.GPCB, 0x000B8FC0), 0x04)
                    Field (NCRG, DWordAcc, Lock, Preserve)
                    {
                        CRGC,   32
                    }

                    If (LGreater (Arg0, 0x02))
                    {
                        Return (0x00)
                    }
                    Else
                    {
                        Store (Arg0, CRGC)
                    }

                    Switch (ToInteger (Arg4))
                    {
                        Case (0x00)
                        {
                            Return (RPCD)
                        }
                        Case (0x02)
                        {
                            Store (Arg1, CAIR)
                            Return (CADR)
                        }
                        Case (0x01)
                        {
                            And (Arg2, RPCD, Local0)
                            Or (Arg3, Local0, Local0)
                            Store (Local0, RPCD)
                        }
                        Case (0x03)
                        {
                            Store (Arg1, CAIR)
                            And (Arg2, CADR, Local0)
                            Or (Arg3, Local0, Local0)
                            Store (Local0, CADR)
                        }
                        Default
                        {
                            Return (0x00)
                        }

                    }
                }

                Method (RPD0, 1, Serialized)
                {
                    RDCA (Arg0, 0xA4, 0xFFFFFFFC, 0x00, 0x01)
                }

                Method (RPD3, 1, Serialized)
                {
                    RDCA (Arg0, 0xA4, 0xFFFFFFFC, 0x03, 0x01)
                }

                Device (NVM1)
                {
                    Name (_ADR, 0x00C1FFFF)  // _ADR: Address
                    Name (PRBI, 0x00)
                    Name (PRBD, 0x00)
                    Name (PCMD, 0x00)
                    Name (NCRN, 0x00)
                    Name (NITV, 0x00)
                    Name (NPMV, 0x00)
                    Name (NPCV, 0x00)
                    Name (NL1V, 0x00)
                    Name (ND2V, 0x00)
                    Name (ND1V, 0x00)
                    Name (NLRV, 0x00)
                    Name (NLDV, 0x00)
                    Name (NEAV, 0x00)
                    Name (NEBV, 0x00)
                    Name (NECV, 0x00)
                    Name (NRAV, 0x00)
                    Name (NMBV, 0x00)
                    Name (NMVV, 0x00)
                    Name (NPBV, 0x00)
                    Name (NPVV, 0x00)
                    Method (EPD0, 0, Serialized)
                    {
                        RDCA (NCRN, Add (NPMV, 0x04), 0xFFFFFFFC, 0x00, 0x03)
                    }

                    Method (EPD3, 0, Serialized)
                    {
                        RDCA (NCRN, Add (NPMV, 0x04), 0xFFFFFFFC, 0x03, 0x03)
                    }

                    Method (CNRS, 0, Serialized)
                    {
                        If (LEqual (NITV, 0x00))
                        {
                            Return (0x00)
                        }

                        RDCA (NCRN, 0x10, 0x00, 0x00, 0x03)
                        RDCA (NCRN, 0x14, 0x00, 0x00, 0x03)
                        RDCA (NCRN, 0x18, 0x00, 0x00, 0x03)
                        RDCA (NCRN, 0x1C, 0x00, 0x00, 0x03)
                        RDCA (NCRN, 0x20, 0x00, 0x00, 0x03)
                        RDCA (NCRN, 0x24, 0x00, 0x00, 0x03)
                        RDCA (NCRN, 0x04, 0xFFFFFFF8, PCMD, 0x03)
                        RDCA (NCRN, PRBI, 0x00, PRBD, 0x03)
                        If (LNotEqual (NL1V, 0x00))
                        {
                            RDCA (NCRN, Add (NL1V, 0x0C), 0xFFFFFF00, ND2V, 0x03)
                            RDCA (NCRN, Add (NL1V, 0x08), 0x0F, And (ND1V, 0xFFFFFFF0), 0x03)
                            RDCA (NCRN, Add (NL1V, 0x08), 0xFFFFFFFF, ND1V, 0x03)
                        }

                        If (LNotEqual (NLRV, 0x00))
                        {
                            RDCA (NCRN, Add (NLRV, 0x04), 0xFFFFFFFF, NLDV, 0x03)
                        }

                        RDCA (NCRN, Add (NPCV, 0x10), 0xFFFFFEBF, And (NEAV, 0xFFFC), 0x03)
                        RDCA (NCRN, Add (NPCV, 0x28), 0xFFFFFBFF, NECV, 0x03)
                        RDCA (NCRN, Add (NPCV, 0x08), 0xFFFFFF1F, NEBV, 0x03)
                        RDCA (NCRN, 0x68, 0xFFFFFBFF, NRAV, 0x01)
                        If (LEqual (And (NEAV, 0x40), 0x40))
                        {
                            RDCA (NCRN, 0x50, 0xFFFFFFDF, 0x20, 0x01)
                            While (LEqual (And (RDCA (NCRN, 0x52, 0x00, 0x00, 0x00), 0x2000), 0x00))
                            {
                                Stall (0x0A)
                            }
                        }

                        RDCA (NCRN, Add (NPCV, 0x10), 0xFFFFFFFC, And (NEAV, 0x03), 0x03)
                        If (LNotEqual (NMVV, 0x00))
                        {
                            RDCA (NCRN, NMBV, 0x00, NMVV, 0x03)
                        }

                        If (LNotEqual (NPVV, 0x00))
                        {
                            RDCA (NCRN, NPBV, 0x00, NPVV, 0x03)
                        }

                        Return (0x00)
                    }

                    Method (_PS3, 0, Serialized)  // _PS3: Power State 3
                    {
                        If (LEqual (NITV, 0x00))
                        {
                            Return (0x00)
                        }

                        Store (RDCA (NCRN, 0x04, 0x00, 0x00, 0x02), PCMD)
                        If (LEqual (NITV, 0x01))
                        {
                            Store (0x24, PRBI)
                            Store (RDCA (NCRN, 0x24, 0x00, 0x00, 0x02), PRBD)
                        }
                        ElseIf (LEqual (NITV, 0x02))
                        {
                            Store (0x10, PRBI)
                            Store (RDCA (NCRN, 0x10, 0x00, 0x00, 0x02), PRBD)
                        }

                        EPD3 ()
                        RPD3 (NCRN)
                        Return (0x00)
                    }

                    Method (_PS0, 0, Serialized)  // _PS0: Power State 0
                    {
                        If (LEqual (NITV, 0x00))
                        {
                            Return (0x00)
                        }

                        RPD0 (NCRN)
                        EPD0 ()
                        Store (RDCA (NCRN, Add (NPMV, 0x04), 0x00, 0x00, 0x02), Local0)
                        If (LEqual (And (Local0, 0x08), 0x00))
                        {
                            CNRS ()
                        }

                        Return (0x00)
                    }

                    Method (_INI, 0, NotSerialized)  // _INI: Initialize
                    {
                        Store (NIT1, NITV)
                        Store (NPM1, NPMV)
                        Store (NPC1, NPCV)
                        Store (NL11, NL1V)
                        Store (ND21, ND2V)
                        Store (ND11, ND1V)
                        Store (NLR1, NLRV)
                        Store (NLD1, NLDV)
                        Store (NEA1, NEAV)
                        Store (NEB1, NEBV)
                        Store (NEC1, NECV)
                        Store (NRA1, NRAV)
                        Store (NMB1, NMBV)
                        Store (NMV1, NMVV)
                        Store (NPB1, NPBV)
                        Store (NPV1, NPVV)
                        Store (0x00, NCRN)
                    }
                }

                Device (NVM2)
                {
                    Name (_ADR, 0x00C2FFFF)  // _ADR: Address
                    Name (PRBI, 0x00)
                    Name (PRBD, 0x00)
                    Name (PCMD, 0x00)
                    Name (NCRN, 0x00)
                    Name (NITV, 0x00)
                    Name (NPMV, 0x00)
                    Name (NPCV, 0x00)
                    Name (NL1V, 0x00)
                    Name (ND2V, 0x00)
                    Name (ND1V, 0x00)
                    Name (NLRV, 0x00)
                    Name (NLDV, 0x00)
                    Name (NEAV, 0x00)
                    Name (NEBV, 0x00)
                    Name (NECV, 0x00)
                    Name (NRAV, 0x00)
                    Name (NMBV, 0x00)
                    Name (NMVV, 0x00)
                    Name (NPBV, 0x00)
                    Name (NPVV, 0x00)
                    Method (EPD0, 0, Serialized)
                    {
                        RDCA (NCRN, Add (NPMV, 0x04), 0xFFFFFFFC, 0x00, 0x03)
                    }

                    Method (EPD3, 0, Serialized)
                    {
                        RDCA (NCRN, Add (NPMV, 0x04), 0xFFFFFFFC, 0x03, 0x03)
                    }

                    Method (CNRS, 0, Serialized)
                    {
                        If (LEqual (NITV, 0x00))
                        {
                            Return (0x00)
                        }

                        RDCA (NCRN, 0x10, 0x00, 0x00, 0x03)
                        RDCA (NCRN, 0x14, 0x00, 0x00, 0x03)
                        RDCA (NCRN, 0x18, 0x00, 0x00, 0x03)
                        RDCA (NCRN, 0x1C, 0x00, 0x00, 0x03)
                        RDCA (NCRN, 0x20, 0x00, 0x00, 0x03)
                        RDCA (NCRN, 0x24, 0x00, 0x00, 0x03)
                        RDCA (NCRN, 0x04, 0xFFFFFFF8, PCMD, 0x03)
                        RDCA (NCRN, PRBI, 0x00, PRBD, 0x03)
                        If (LNotEqual (NL1V, 0x00))
                        {
                            RDCA (NCRN, Add (NL1V, 0x0C), 0xFFFFFF00, ND2V, 0x03)
                            RDCA (NCRN, Add (NL1V, 0x08), 0x0F, And (ND1V, 0xFFFFFFF0), 0x03)
                            RDCA (NCRN, Add (NL1V, 0x08), 0xFFFFFFFF, ND1V, 0x03)
                        }

                        If (LNotEqual (NLRV, 0x00))
                        {
                            RDCA (NCRN, Add (NLRV, 0x04), 0xFFFFFFFF, NLDV, 0x03)
                        }

                        RDCA (NCRN, Add (NPCV, 0x10), 0xFFFFFEBF, And (NEAV, 0xFFFC), 0x03)
                        RDCA (NCRN, Add (NPCV, 0x28), 0xFFFFFBFF, NECV, 0x03)
                        RDCA (NCRN, Add (NPCV, 0x08), 0xFFFFFF1F, NEBV, 0x03)
                        RDCA (NCRN, 0x68, 0xFFFFFBFF, NRAV, 0x01)
                        If (LEqual (And (NEAV, 0x40), 0x40))
                        {
                            RDCA (NCRN, 0x50, 0xFFFFFFDF, 0x20, 0x01)
                            While (LEqual (And (RDCA (NCRN, 0x52, 0x00, 0x00, 0x00), 0x2000), 0x00))
                            {
                                Stall (0x0A)
                            }
                        }

                        RDCA (NCRN, Add (NPCV, 0x10), 0xFFFFFFFC, And (NEAV, 0x03), 0x03)
                        If (LNotEqual (NMVV, 0x00))
                        {
                            RDCA (NCRN, NMBV, 0x00, NMVV, 0x03)
                        }

                        If (LNotEqual (NPVV, 0x00))
                        {
                            RDCA (NCRN, NPBV, 0x00, NPVV, 0x03)
                        }

                        Return (0x00)
                    }

                    Method (_PS3, 0, Serialized)  // _PS3: Power State 3
                    {
                        If (LEqual (NITV, 0x00))
                        {
                            Return (0x00)
                        }

                        Store (RDCA (NCRN, 0x04, 0x00, 0x00, 0x02), PCMD)
                        If (LEqual (NITV, 0x01))
                        {
                            Store (0x24, PRBI)
                            Store (RDCA (NCRN, 0x24, 0x00, 0x00, 0x02), PRBD)
                        }
                        ElseIf (LEqual (NITV, 0x02))
                        {
                            Store (0x10, PRBI)
                            Store (RDCA (NCRN, 0x10, 0x00, 0x00, 0x02), PRBD)
                        }

                        EPD3 ()
                        RPD3 (NCRN)
                        Return (0x00)
                    }

                    Method (_PS0, 0, Serialized)  // _PS0: Power State 0
                    {
                        If (LEqual (NITV, 0x00))
                        {
                            Return (0x00)
                        }

                        RPD0 (NCRN)
                        EPD0 ()
                        Store (RDCA (NCRN, Add (NPMV, 0x04), 0x00, 0x00, 0x02), Local0)
                        If (LEqual (And (Local0, 0x08), 0x00))
                        {
                            CNRS ()
                        }

                        Return (0x00)
                    }

                    Method (_INI, 0, NotSerialized)  // _INI: Initialize
                    {
                        Store (NIT2, NITV)
                        Store (NPM2, NPMV)
                        Store (NPC2, NPCV)
                        Store (NL12, NL1V)
                        Store (ND22, ND2V)
                        Store (ND12, ND1V)
                        Store (NLR2, NLRV)
                        Store (NLD2, NLDV)
                        Store (NEA2, NEAV)
                        Store (NEB2, NEBV)
                        Store (NEC2, NECV)
                        Store (NRA2, NRAV)
                        Store (NMB2, NMBV)
                        Store (NMV2, NMVV)
                        Store (NPB2, NPBV)
                        Store (NPV2, NPVV)
                        Store (0x01, NCRN)
                    }
                }

                Device (NVM3)
                {
                    Name (_ADR, 0x00C3FFFF)  // _ADR: Address
                    Name (PRBI, 0x00)
                    Name (PRBD, 0x00)
                    Name (PCMD, 0x00)
                    Name (NCRN, 0x00)
                    Name (NITV, 0x00)
                    Name (NPMV, 0x00)
                    Name (NPCV, 0x00)
                    Name (NL1V, 0x00)
                    Name (ND2V, 0x00)
                    Name (ND1V, 0x00)
                    Name (NLRV, 0x00)
                    Name (NLDV, 0x00)
                    Name (NEAV, 0x00)
                    Name (NEBV, 0x00)
                    Name (NECV, 0x00)
                    Name (NRAV, 0x00)
                    Name (NMBV, 0x00)
                    Name (NMVV, 0x00)
                    Name (NPBV, 0x00)
                    Name (NPVV, 0x00)
                    Method (EPD0, 0, Serialized)
                    {
                        RDCA (NCRN, Add (NPMV, 0x04), 0xFFFFFFFC, 0x00, 0x03)
                    }

                    Method (EPD3, 0, Serialized)
                    {
                        RDCA (NCRN, Add (NPMV, 0x04), 0xFFFFFFFC, 0x03, 0x03)
                    }

                    Method (CNRS, 0, Serialized)
                    {
                        If (LEqual (NITV, 0x00))
                        {
                            Return (0x00)
                        }

                        RDCA (NCRN, 0x10, 0x00, 0x00, 0x03)
                        RDCA (NCRN, 0x14, 0x00, 0x00, 0x03)
                        RDCA (NCRN, 0x18, 0x00, 0x00, 0x03)
                        RDCA (NCRN, 0x1C, 0x00, 0x00, 0x03)
                        RDCA (NCRN, 0x20, 0x00, 0x00, 0x03)
                        RDCA (NCRN, 0x24, 0x00, 0x00, 0x03)
                        RDCA (NCRN, 0x04, 0xFFFFFFF8, PCMD, 0x03)
                        RDCA (NCRN, PRBI, 0x00, PRBD, 0x03)
                        If (LNotEqual (NL1V, 0x00))
                        {
                            RDCA (NCRN, Add (NL1V, 0x0C), 0xFFFFFF00, ND2V, 0x03)
                            RDCA (NCRN, Add (NL1V, 0x08), 0x0F, And (ND1V, 0xFFFFFFF0), 0x03)
                            RDCA (NCRN, Add (NL1V, 0x08), 0xFFFFFFFF, ND1V, 0x03)
                        }

                        If (LNotEqual (NLRV, 0x00))
                        {
                            RDCA (NCRN, Add (NLRV, 0x04), 0xFFFFFFFF, NLDV, 0x03)
                        }

                        RDCA (NCRN, Add (NPCV, 0x10), 0xFFFFFEBF, And (NEAV, 0xFFFC), 0x03)
                        RDCA (NCRN, Add (NPCV, 0x28), 0xFFFFFBFF, NECV, 0x03)
                        RDCA (NCRN, Add (NPCV, 0x08), 0xFFFFFF1F, NEBV, 0x03)
                        RDCA (NCRN, 0x68, 0xFFFFFBFF, NRAV, 0x01)
                        If (LEqual (And (NEAV, 0x40), 0x40))
                        {
                            RDCA (NCRN, 0x50, 0xFFFFFFDF, 0x20, 0x01)
                            While (LEqual (And (RDCA (NCRN, 0x52, 0x00, 0x00, 0x00), 0x2000), 0x00))
                            {
                                Stall (0x0A)
                            }
                        }

                        RDCA (NCRN, Add (NPCV, 0x10), 0xFFFFFFFC, And (NEAV, 0x03), 0x03)
                        If (LNotEqual (NMVV, 0x00))
                        {
                            RDCA (NCRN, NMBV, 0x00, NMVV, 0x03)
                        }

                        If (LNotEqual (NPVV, 0x00))
                        {
                            RDCA (NCRN, NPBV, 0x00, NPVV, 0x03)
                        }

                        Return (0x00)
                    }

                    Method (_PS3, 0, Serialized)  // _PS3: Power State 3
                    {
                        If (LEqual (NITV, 0x00))
                        {
                            Return (0x00)
                        }

                        Store (RDCA (NCRN, 0x04, 0x00, 0x00, 0x02), PCMD)
                        If (LEqual (NITV, 0x01))
                        {
                            Store (0x24, PRBI)
                            Store (RDCA (NCRN, 0x24, 0x00, 0x00, 0x02), PRBD)
                        }
                        ElseIf (LEqual (NITV, 0x02))
                        {
                            Store (0x10, PRBI)
                            Store (RDCA (NCRN, 0x10, 0x00, 0x00, 0x02), PRBD)
                        }

                        EPD3 ()
                        RPD3 (NCRN)
                        Return (0x00)
                    }

                    Method (_PS0, 0, Serialized)  // _PS0: Power State 0
                    {
                        If (LEqual (NITV, 0x00))
                        {
                            Return (0x00)
                        }

                        RPD0 (NCRN)
                        EPD0 ()
                        Store (RDCA (NCRN, Add (NPMV, 0x04), 0x00, 0x00, 0x02), Local0)
                        If (LEqual (And (Local0, 0x08), 0x00))
                        {
                            CNRS ()
                        }

                        Return (0x00)
                    }

                    Method (_INI, 0, NotSerialized)  // _INI: Initialize
                    {
                        Store (NIT3, NITV)
                        Store (NPM3, NPMV)
                        Store (NPC3, NPCV)
                        Store (NL13, NL1V)
                        Store (ND23, ND2V)
                        Store (ND13, ND1V)
                        Store (NLR3, NLRV)
                        Store (NLD3, NLDV)
                        Store (NEA3, NEAV)
                        Store (NEB3, NEBV)
                        Store (NEC3, NECV)
                        Store (NRA3, NRAV)
                        Store (NMB3, NMBV)
                        Store (NMV3, NMVV)
                        Store (NPB3, NPBV)
                        Store (NPV3, NPVV)
                        Store (0x02, NCRN)
                    }
                }
            }

            Method (_SDD, 1, NotSerialized)  // _SDD: Set Device Data
            {
                Store (0x00, DIP0)
                If (LEqual (SizeOf (Arg0), 0x0200))
                {
                    CreateWordField (Arg0, 0x9C, M078)
                    If (LAnd (\DPP0, And (M078, 0x08)))
                    {
                        Store (0x01, DIP0)
                    }

                    CreateByteField (Arg0, 0x9D, BFDS)
                    ToInteger (BFDS, FDEV)
                    CreateByteField (Arg0, 0x9A, BFRP)
                    ToInteger (BFRP, FDRP)
                }
            }

            Method (_GTF, 0, NotSerialized)  // _GTF: Get Task File
            {
                If (DIP0)
                {
                    If (LAnd (LAnd (LEqual (DVS0, 0x01), LEqual (And (FDEV, 0x01), 0x01)), LEqual (And (FDRP, 0x80), 0x80)))
                    {
                        Return (HQTF)
                    }
                    Else
                    {
                        Return (HPTF)
                    }
                }
                ElseIf (LAnd (LAnd (LEqual (DVS0, 0x01), LEqual (And (FDEV, 0x01), 0x01)), LEqual (And (FDRP, 0x80), 0x80)))
                {
                    Return (HETF)
                }
                Else
                {
                    Return (HDTF)
                }
            }
        }

        Device (PRT1)
        {
            Name (DIP0, 0x00)
            Name (FDEV, 0x00)
            Name (FDRP, 0x00)
            Name (HDTF, Buffer (0x0E)
            {
                /* 0000 */  0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00,
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5             
            })
            Name (HETF, Buffer (0x15)
            {
                /* 0000 */  0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00,
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5, 0x10, 0x09,
                /* 0010 */  0x00, 0x00, 0x00, 0xA0, 0xEF                   
            })
            Name (ERTF, Buffer (0x15)
            {
                /* 0000 */  0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00,
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5, 0x5F, 0x00,
                /* 0010 */  0x00, 0x00, 0x00, 0xA0, 0xEF                   
            })
            Name (HPTF, Buffer (0x15)
            {
                /* 0000 */  0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00,
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5, 0x10, 0x03,
                /* 0010 */  0x00, 0x00, 0x00, 0xA0, 0xEF                   
            })
            Name (HQTF, Buffer (0x1C)
            {
                /* 0000 */  0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00,
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5, 0x10, 0x03,
                /* 0010 */  0x00, 0x00, 0x00, 0xA0, 0xEF, 0x10, 0x09, 0x00,
                /* 0018 */  0x00, 0x00, 0xA0, 0xEF                         
            })
            Name (HXTF, Buffer (0x1C)
            {
                /* 0000 */  0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00,
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5, 0x5F, 0x00,
                /* 0010 */  0x00, 0x00, 0x00, 0xA0, 0xEF, 0x10, 0x03, 0x00,
                /* 0018 */  0x00, 0x00, 0xA0, 0xEF                         
            })
            Name (DDTF, Buffer (0x0E)
            {
                /* 0000 */  0x00, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xE3, 0x00,
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xE3             
            })
            CreateByteField (DDTF, 0x01, DTAT)
            CreateByteField (DDTF, 0x08, DTFT)
            Name (DGTF, Buffer (0x15)
            {
                /* 0000 */  0x00, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xE3, 0x00,
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xE3, 0x10, 0x03,
                /* 0010 */  0x00, 0x00, 0x00, 0xA0, 0xEF                   
            })
            CreateByteField (DGTF, 0x01, GTAT)
            CreateByteField (DGTF, 0x08, GTFT)
            Name (_ADR, 0x0001FFFF)  // _ADR: Address
            Method (_SDD, 1, NotSerialized)  // _SDD: Set Device Data
            {
                Store (0x00, DIP0)
                If (LEqual (SizeOf (Arg0), 0x0200))
                {
                    CreateWordField (Arg0, 0x9C, M078)
                    If (LAnd (\DPP1, And (M078, 0x08)))
                    {
                        Store (0x01, DIP0)
                    }

                    CreateByteField (Arg0, 0x9D, BFDS)
                    ToInteger (BFDS, FDEV)
                    CreateByteField (Arg0, 0x9A, BFRP)
                    ToInteger (BFRP, FDRP)
                }
            }

            Method (_GTF, 0, NotSerialized)  // _GTF: Get Task File
            {
                If (DIP0)
                {
                    If (LAnd (LAnd (LEqual (DVS1, 0x01), LEqual (And (FDEV, 0x01), 0x01)), LEqual (And (FDRP, 0x80), 0x80)))
                    {
                        Return (HQTF)
                    }
                    Else
                    {
                        Return (HPTF)
                    }
                }
                ElseIf (LAnd (LAnd (LEqual (DVS1, 0x01), LEqual (And (FDEV, 0x01), 0x01)), LEqual (And (FDRP, 0x80), 0x80)))
                {
                    Return (HETF)
                }
                Else
                {
                    Return (HDTF)
                }
            }
        }

        Device (PRT2)
        {
            Name (DIP0, 0x00)
            Name (FDEV, 0x00)
            Name (FDRP, 0x00)
            Name (HDTF, Buffer (0x0E)
            {
                /* 0000 */  0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00,
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5             
            })
            Name (HETF, Buffer (0x15)
            {
                /* 0000 */  0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00,
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5, 0x10, 0x09,
                /* 0010 */  0x00, 0x00, 0x00, 0xA0, 0xEF                   
            })
            Name (ERTF, Buffer (0x15)
            {
                /* 0000 */  0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00,
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5, 0x5F, 0x00,
                /* 0010 */  0x00, 0x00, 0x00, 0xA0, 0xEF                   
            })
            Name (HPTF, Buffer (0x15)
            {
                /* 0000 */  0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00,
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5, 0x10, 0x03,
                /* 0010 */  0x00, 0x00, 0x00, 0xA0, 0xEF                   
            })
            Name (HQTF, Buffer (0x1C)
            {
                /* 0000 */  0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00,
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5, 0x10, 0x03,
                /* 0010 */  0x00, 0x00, 0x00, 0xA0, 0xEF, 0x10, 0x09, 0x00,
                /* 0018 */  0x00, 0x00, 0xA0, 0xEF                         
            })
            Name (HXTF, Buffer (0x1C)
            {
                /* 0000 */  0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00,
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5, 0x5F, 0x00,
                /* 0010 */  0x00, 0x00, 0x00, 0xA0, 0xEF, 0x10, 0x03, 0x00,
                /* 0018 */  0x00, 0x00, 0xA0, 0xEF                         
            })
            Name (DDTF, Buffer (0x0E)
            {
                /* 0000 */  0x00, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xE3, 0x00,
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xE3             
            })
            CreateByteField (DDTF, 0x01, DTAT)
            CreateByteField (DDTF, 0x08, DTFT)
            Name (DGTF, Buffer (0x15)
            {
                /* 0000 */  0x00, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xE3, 0x00,
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xE3, 0x10, 0x03,
                /* 0010 */  0x00, 0x00, 0x00, 0xA0, 0xEF                   
            })
            CreateByteField (DGTF, 0x01, GTAT)
            CreateByteField (DGTF, 0x08, GTFT)
            Name (_ADR, 0x0002FFFF)  // _ADR: Address
            Method (_SDD, 1, NotSerialized)  // _SDD: Set Device Data
            {
                Store (0x00, DIP0)
                If (LEqual (SizeOf (Arg0), 0x0200))
                {
                    CreateWordField (Arg0, 0x9C, M078)
                    If (LAnd (\DPP2, And (M078, 0x08)))
                    {
                        Store (0x01, DIP0)
                    }

                    CreateByteField (Arg0, 0x9D, BFDS)
                    ToInteger (BFDS, FDEV)
                    CreateByteField (Arg0, 0x9A, BFRP)
                    ToInteger (BFRP, FDRP)
                }
            }

            Method (_GTF, 0, NotSerialized)  // _GTF: Get Task File
            {
                If (DIP0)
                {
                    If (LAnd (LAnd (LEqual (DVS2, 0x01), LEqual (And (FDEV, 0x01), 0x01)), LEqual (And (FDRP, 0x80), 0x80)))
                    {
                        Return (HQTF)
                    }
                    Else
                    {
                        Return (HPTF)
                    }
                }
                ElseIf (LAnd (LAnd (LEqual (DVS2, 0x01), LEqual (And (FDEV, 0x01), 0x01)), LEqual (And (FDRP, 0x80), 0x80)))
                {
                    Return (HETF)
                }
                Else
                {
                    Return (HDTF)
                }
            }
        }

        Device (PRT3)
        {
            Name (DIP0, 0x00)
            Name (FDEV, 0x00)
            Name (FDRP, 0x00)
            Name (HDTF, Buffer (0x0E)
            {
                /* 0000 */  0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00,
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5             
            })
            Name (HETF, Buffer (0x15)
            {
                /* 0000 */  0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00,
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5, 0x10, 0x09,
                /* 0010 */  0x00, 0x00, 0x00, 0xA0, 0xEF                   
            })
            Name (ERTF, Buffer (0x15)
            {
                /* 0000 */  0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00,
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5, 0x5F, 0x00,
                /* 0010 */  0x00, 0x00, 0x00, 0xA0, 0xEF                   
            })
            Name (HPTF, Buffer (0x15)
            {
                /* 0000 */  0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00,
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5, 0x10, 0x03,
                /* 0010 */  0x00, 0x00, 0x00, 0xA0, 0xEF                   
            })
            Name (HQTF, Buffer (0x1C)
            {
                /* 0000 */  0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00,
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5, 0x10, 0x03,
                /* 0010 */  0x00, 0x00, 0x00, 0xA0, 0xEF, 0x10, 0x09, 0x00,
                /* 0018 */  0x00, 0x00, 0xA0, 0xEF                         
            })
            Name (HXTF, Buffer (0x1C)
            {
                /* 0000 */  0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00,
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5, 0x5F, 0x00,
                /* 0010 */  0x00, 0x00, 0x00, 0xA0, 0xEF, 0x10, 0x03, 0x00,
                /* 0018 */  0x00, 0x00, 0xA0, 0xEF                         
            })
            Name (DDTF, Buffer (0x0E)
            {
                /* 0000 */  0x00, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xE3, 0x00,
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xE3             
            })
            CreateByteField (DDTF, 0x01, DTAT)
            CreateByteField (DDTF, 0x08, DTFT)
            Name (DGTF, Buffer (0x15)
            {
                /* 0000 */  0x00, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xE3, 0x00,
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xE3, 0x10, 0x03,
                /* 0010 */  0x00, 0x00, 0x00, 0xA0, 0xEF                   
            })
            CreateByteField (DGTF, 0x01, GTAT)
            CreateByteField (DGTF, 0x08, GTFT)
            Name (_ADR, 0x0003FFFF)  // _ADR: Address
            Method (_SDD, 1, NotSerialized)  // _SDD: Set Device Data
            {
                Store (0x00, DIP0)
                If (LEqual (SizeOf (Arg0), 0x0200))
                {
                    CreateWordField (Arg0, 0x9C, M078)
                    If (LAnd (\DPP3, And (M078, 0x08)))
                    {
                        Store (0x01, DIP0)
                    }

                    CreateByteField (Arg0, 0x9D, BFDS)
                    ToInteger (BFDS, FDEV)
                    CreateByteField (Arg0, 0x9A, BFRP)
                    ToInteger (BFRP, FDRP)
                }
            }

            Method (_GTF, 0, NotSerialized)  // _GTF: Get Task File
            {
                If (DIP0)
                {
                    If (LAnd (LAnd (LEqual (DVS3, 0x01), LEqual (And (FDEV, 0x01), 0x01)), LEqual (And (FDRP, 0x80), 0x80)))
                    {
                        Return (HQTF)
                    }
                    Else
                    {
                        Return (HPTF)
                    }
                }
                ElseIf (LAnd (LAnd (LEqual (DVS3, 0x01), LEqual (And (FDEV, 0x01), 0x01)), LEqual (And (FDRP, 0x80), 0x80)))
                {
                    Return (HETF)
                }
                Else
                {
                    Return (HDTF)
                }
            }
        }

        Device (PRT4)
        {
            Name (DIP0, 0x00)
            Name (HDTF, Buffer (0x0E)
            {
                /* 0000 */  0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00,
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5             
            })
            Name (HETF, Buffer (0x15)
            {
                /* 0000 */  0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00,
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5, 0x10, 0x09,
                /* 0010 */  0x00, 0x00, 0x00, 0xA0, 0xEF                   
            })
            Name (ERTF, Buffer (0x15)
            {
                /* 0000 */  0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00,
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5, 0x5F, 0x00,
                /* 0010 */  0x00, 0x00, 0x00, 0xA0, 0xEF                   
            })
            Name (HPTF, Buffer (0x15)
            {
                /* 0000 */  0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00,
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5, 0x10, 0x03,
                /* 0010 */  0x00, 0x00, 0x00, 0xA0, 0xEF                   
            })
            Name (HQTF, Buffer (0x1C)
            {
                /* 0000 */  0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00,
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5, 0x10, 0x03,
                /* 0010 */  0x00, 0x00, 0x00, 0xA0, 0xEF, 0x10, 0x09, 0x00,
                /* 0018 */  0x00, 0x00, 0xA0, 0xEF                         
            })
            Name (HXTF, Buffer (0x1C)
            {
                /* 0000 */  0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00,
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5, 0x5F, 0x00,
                /* 0010 */  0x00, 0x00, 0x00, 0xA0, 0xEF, 0x10, 0x03, 0x00,
                /* 0018 */  0x00, 0x00, 0xA0, 0xEF                         
            })
            Name (DDTF, Buffer (0x0E)
            {
                /* 0000 */  0x00, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xE3, 0x00,
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xE3             
            })
            CreateByteField (DDTF, 0x01, DTAT)
            CreateByteField (DDTF, 0x08, DTFT)
            Name (DGTF, Buffer (0x15)
            {
                /* 0000 */  0x00, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xE3, 0x00,
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xE3, 0x10, 0x03,
                /* 0010 */  0x00, 0x00, 0x00, 0xA0, 0xEF                   
            })
            CreateByteField (DGTF, 0x01, GTAT)
            CreateByteField (DGTF, 0x08, GTFT)
            Name (_ADR, 0x0004FFFF)  // _ADR: Address
            Method (_SDD, 1, NotSerialized)  // _SDD: Set Device Data
            {
                Store (0x00, DIP0)
                If (LEqual (SizeOf (Arg0), 0x0200))
                {
                    CreateWordField (Arg0, 0x9C, M078)
                    If (LAnd (\DPP4, And (M078, 0x08)))
                    {
                        Store (0x01, DIP0)
                    }
                }
            }

            Method (_GTF, 0, NotSerialized)  // _GTF: Get Task File
            {
                If (DIP0)
                {
                    Return (HPTF)
                }

                Return (HDTF)
            }
        }
    }
}

